Prime Path
Time Limit:
1000MS
Memory Limit: 65536K
Description

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
提示:使用一个结构保存数和路径长度。
处理4位数也可以使用字符串,详见这篇文章。
完整代码:
/*0ms,160KB*/
///还可以设计一个保存搜索结果的算法
#include <cstdio>
#include <cstring>
#include <queue>
using namespace std;
int m, n;
bool pr[10000],vis[10000];
struct st
{
int x, v;
st(int xx, int vv): x(xx), v(vv) {}
};
inline void init()
{
for (int i = 2; i < 100; i++)
if (!pr[i])
for (int j = i * i; j < 10000; j += i)
pr[j] = true;
}
inline int bfs()
{
memset(vis, 0, sizeof(vis));
queue<st> q;
q.push(st(m, 0));///起点
vis[m] = true;
while (!q.empty())
{
st u = q.front();
q.pop();
for (int t = 1; t <= 1000; t *= 10)
{
int a = (u.x / t) % 10;
int b = (u.x - a * t);
for (int j = 0; j < 10; j++)
{
int c = b + j * t;///精妙的设计
if (vis[c] || pr[c] || j == a || (t == 1000 && j == 0))///千位不能是0
continue;
if (c == n)///到终点了
return u.v + 1;
q.push(st(c, u.v + 1));
vis[c] = true;
}
}
}
return -1;
}
int main()
{
init();
int t;
scanf("%d", &t);
while (t--)
{
scanf("%d%d", &m, &n);
int ans = (m != n ? bfs() : 0);
if (~ans)
printf("%d\n", ans);
else
puts("Impossible");
}
return 0;
}